//---------------------------------------------------------------------------
#include <vcl.h>

#pragma hdrstop

#include "algo.h"
#include "repere.h"
#include "box.h"
#define ny 10

//---------------------------------------------------------------------------
#pragma package(smart_init)
extern double epsilon;

interval UP1;
interval UP2;
interval UY[ny+1];
interval UT[ny+1];
interval Y[ny+1];
interval Ym[ny+1];
interval T[ny+1];
interval Tm[ny+1];

interval Z1[ny+1];
interval Z2[ny+1];

void Init()
{   T[1]=interval(0,1);
    T[2]=interval(1,7);
    T[3]=interval(1,7);
    T[4]=interval(3,4);
    T[5]=interval(5,7);
    T[6]=interval(8,10);
    T[7]=interval(12,14);
    T[8]=interval(16,18);
    T[9]=interval(20,22);
    T[10]=interval(24,26);

    Y[1]=interval(7,12);
    Y[2]=interval(0,2);
    Y[3]=interval(6,7);
    Y[4]=interval(-1,3);
    Y[5]=interval(-9,-3);
    Y[6]=interval(-5,-1);
    Y[7]=interval(-4,3);
    Y[8]=interval(-3,1);
    Y[9]=interval(-3,1);
    Y[10]=interval(-2,2);

    UP1.isEmpty=true;
    UP2.isEmpty=true;
    for(int k=1;k<=ny;k++)
    {     UT[k].isEmpty=true;
          UY[k].isEmpty=true;
    }
}

iboolean Contract(repere& R,box& P)
{   iboolean dedans=itrue;
    if (P.isEmpty) return (ifalse);
    for(int k=1;k<=ny;k++) Tm[k]=T[k];
    box Pa(2,true);
    do
    {   //Tm[2]=Inter(Tm[2],interval(0,Sup(Tm[3])));            Pour montrer que la contrainte t2<t3 entraine
        //Tm[3]=Inter(Tm[3],interval(Inf(Tm[3]),1000));         qu'il n'y a pas de solutions.
        Pa=P;
        R.DrawCadre (P,clBlack,psSolid,1,2);
        for(int k=1;k<=ny;k++)
        {   Z1[k]=20*Exp(-P[1]*Tm[k]);
            Z2[k]=8*Exp(-P[2]*Tm[k]);
            Ym[k]=Z1[k]-Z2[k];
            Ym[k]=Inter(Ym[k],Y[k]);
            if (Ym[k].isEmpty) {P.isEmpty=true;return ifalse;}
        }
        for(int k=1;k<=ny;k++)
        {   Z1[k]     =Inter(Ym[k]+Z2[k],Z1[k]);
            Z2[k]     =Inter(Z1[k]-Ym[k],Z2[k]);
            Tm[k]     =Inter((-Log(Z1[k]/20))/P[1],Tm[k]);
            P[1]      =Inter((-Log(Z1[k]/20))/Tm[k],P[1]);
            Tm[k]     =Inter((-Log(Z2[k]/8))/P[2],Tm[k]);
            P[2]      =Inter((-Log(Z2[k]/8))/Tm[k],P[2]);
        }
        if ((P[1].isEmpty)||(P[2].isEmpty))  {P.isEmpty=true; return ifalse;}
    }
    while (Eloignement2(Pa,P)>0.00001);
    return iperhaps;
};



void SIVIA(repere& R,box& P)
{   box P1(2,true);
    box P2(2,true);
    if (Width(P)<epsilon)
    {     iboolean test;
          test=Contract(R,P);
          R.DrawBox(P,clYellow,clYellow,bsSolid);
          UP1=Union(UP1,P[1]);
          UP2=Union(UP2,P[2]);
          for (int k=1;k<=ny;k++)
          {  UY[k]=Union(Ym[k],UY[k]);
             UT[k]=Union(Tm[k],UT[k]);
          }
          return;
    };
    iboolean test;
    test=Contract(R,P);
    if (test==itrue) R.DrawBox(P,clRed,clPurple,bsSolid);
    if (test!=ifalse)
         {  Bisect(P,P1,P2);
            SIVIA(R,P1);
            SIVIA(R,P2);
         }
    else R.DrawBox(P,clBlue,clAqua,bsSolid);
} ;



void Go(repere& R,box& P,int i)
{   if (i==0) {Init(); SIVIA(R,P); P[1]=UP1; P[2]=UP2;}
    if (i==1)
    {       R.interval_x=interval(-1,30);
            R.interval_y=interval(-15,15);
            box TY(2,true); TY[1]=R.interval_x; TY[2]=R.interval_y;
            R.DrawBox(TY,clWhite,clWhite,bsSolid);
            for (int k=1;k<=ny;k++)
            {   TY[1]=T[k];
                TY[2]=Y[k];
                R.DrawCadre(TY,clBlue,psSolid,2);
                TY[1]=UT[k];
                TY[2]=UY[k];
                R.DrawBox(TY,clLtGray,clPurple,bsSolid);
            };
    }

} ;

